package com.zt.plat.module.qms.resource.material.service;

import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.resource.material.controller.vo.*;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductPageReqVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductRespVO;
import com.zt.plat.module.qms.resource.material.controller.vo.MaterialProductSaveReqVO;
import com.zt.plat.module.qms.resource.material.dal.dataobject.MaterialProductDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 物料大类 Service 接口
 *
 * @author 后台管理
 */
public interface MaterialProductService {

    //保存分类
    CommonResult<MaterialProductRespVO> saveCategory(@Valid MaterialProductSaveReqVO createReqVO);

    //保存数据
    CommonResult<MaterialProductRespVO> saveData(@Valid MaterialProductSaveReqVO createReqVO);

    /*获取分类树数据*/
    List<MaterialProductDO> getTreeData(String nodeType);

    List<MaterialProductDO> listByParId(Long parId, String nodeType);
    List<MaterialProductDO> listByIdPath(Long id, String nodeType);

    CommonResult<String> updateAllIdPath(Long parentId, Integer level);
    /**
     * 创建物料大类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    MaterialProductRespVO createMaterialProduct(@Valid MaterialProductSaveReqVO createReqVO);

    /**
     * 更新物料大类
     *
     * @param updateReqVO 更新信息
     */
    void updateMaterialProduct(@Valid MaterialProductSaveReqVO updateReqVO);

    /**
     * 删除物料大类
     *
     * @param id 编号
     */
    void deleteMaterialProduct(Long id);

    /**
    * 批量删除物料大类
    *
    * @param ids 编号
    */
    void deleteMaterialProductListByIds(List<Long> ids);

    /**
     * 获得物料大类
     *
     * @param id 编号
     * @return 物料大类
     */
    MaterialProductDO getMaterialProduct(Long id);

    /**
     * 获得物料大类分页
     *
     * @param pageReqVO 分页查询
     * @return 物料大类分页
     */
    PageResult<MaterialProductDO> getMaterialProductPage(MaterialProductPageReqVO pageReqVO);

}